<?php

namespace FM\Service;

use FM\Factory\ChecklistAgendFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\LogtransfAgendService;

class ChecklistAgendService {

    protected $connection;
    protected $ChecklistAgendFactory;
    protected $Environment;
    protected $newCode;
    protected $LogtransfAgendService;

    public function __construct (EntityManager $entityManager,LogtransfAgendService $LogtransfAgendService, ChecklistAgendFactory $ChecklistAgendFactory, Environment $Environment, NewCode $newCode) {
        $this->connection = $entityManager->getConnection();
        $this->ChecklistAgendFactory = $ChecklistAgendFactory;
        $this->LogtransfAgendService = $LogtransfAgendService;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function listTask($param){
        $params = "";
        if($param["uni"] != "null"){
            $params .= " AND FCM_LOCALCLI.NRLOCALCLIENTEPAI in (SELECT FCM_LOCALCLI.NRLOCALCLIENTE FROM FCM_LOCALCLI
            WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = ".$param["uni"].")";
        }
        if($param["loc"] != "null"){
            $params .= " AND FCM_CHECKLISTAGEND.NRLOCALCLIENTE = ".$param["loc"];
        }
        if($param["sec"] != "null"){  
            $params .= " AND FCM_LOCALCLI.NRSETOR = ".$param["sec"];
        }
        if($param["lct"] != "null"){
            $params .= " AND FCM_CHECKLISTAGEND.NRCHECKLIST IN (SELECT FCM_ATIVIDADECHK.NRCHECKLIST
            FROM FCM_ATIVIDADECHK
           WHERE FCM_ATIVIDADECHK.NRATIVIDADE = ".$param["lct"].")";
        }
        if($param["tst"] != "null"){
            $params .= " AND FCM_LOCALCLI.NRTIPOLOCALCLI = ".$param["tst"];
        }

        $operadores = $this->ChecklistAgendFactory->listTask(array(
            "startPeriod"    => $param['start'],
            "finishPeriod"   => $param['finish'],
            "nr" => intval($param['nr'])
        ),$params);
        return $operadores;
    }

    public function infoTask($param){
        $operadores = $this->ChecklistAgendFactory->infoTask(array(
            "nome" => $param['name'],
            "startPeriod"    => $param['start'],
            "finishPeriod"   => $param['end'],
            "nr" => intval($param['nr'])
        ));
        return $operadores;
    }

    public function taskOfTheEmployee($param){
        if($param["inicio"] == "null" && $param["fim"] == "null"){
            $parametroCheck = "";
            $parametroGer = "";
        }elseif($param["inicio"] == "null"){
            $parametroCheck = "AND TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) <= TO_DATE('".$param["fim"]."', 'DD/MM/YYYY')";
            $parametroGer = "AND TRUNC(FCM_GERENCIAMENTOCHK.DTHORAAGEND) <= TO_DATE('".$param["fim"]."', 'DD/MM/YYYY')";
        }elseif($param["fim"] == "null"){
            $parametroCheck = "AND TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) >= TO_DATE('".$param["inicio"]."', 'DD/MM/YYYY')";
            $parametroGer = "AND TRUNC(FCM_GERENCIAMENTOCHK.DTHORAAGEND) >= TO_DATE('".$param["inicio"]."', 'DD/MM/YYYY')";
        }else {
            $parametroCheck = "AND TRUNC(FCM_CHECKLISTAGEND.DTHORAAGEND) BETWEEN TO_DATE('".$param["inicio"]."', 'DD/MM/YYYY') AND TO_DATE('".$param["fim"]."', 'DD/MM/YYYY')";
            $parametroGer = "AND TRUNC(FCM_GERENCIAMENTOCHK.DTHORAAGEND) BETWEEN TO_DATE('".$param["inicio"]."', 'DD/MM/YYYY') AND TO_DATE('".$param["fim"]."', 'DD/MM/YYYY')";
        }
        $operadores = $this->ChecklistAgendFactory->taskOfTheEmployee(array("nr" => intval($param['nr'])),$parametroGer,$parametroCheck);
        return $operadores;
    }

    public function transferTask($param){
        $this->connection->beginTransaction();
        
        try {
            $this->ChecklistAgendFactory->transferTask(array(
                "nr" => intval($param['funcionarioDestino']),
                "list" => implode(',', $param['idTarefa'])
            ));
            
            foreach($param['idTarefa'] as $id){
                $dadosHistorico = $this->ChecklistAgendFactory->dadosTask($id);
                $dadosHistorico = $dadosHistorico[0];
                $dadosHistorico['funcionarioOrigem'] = $param['funcionarioOrigem'];
                $dadosHistorico['funcionarioDestino'] = $param['funcionarioDestino'];
                $dadosHistorico['operadorTransfer'] = $param['operadorTransfer'];
                $this->LogtransfAgendService->insertLogTrasnfer($dadosHistorico);
            }

            $this->connection->commit();
            $status = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $status = "ERROR";
        }
        
        return $status;
    }
}

?>